ghc-7.0.3: The GHC API

FunDeps

# Documentation

data FDEq

Constructors

FDEq |

Fields

fd_pos :: Int
fd_ty_left :: Type
fd_ty_right :: Type

data Equation

Constructors

FDEqn |

Fields

fd_qtvs :: TyVarSet
fd_eqs :: [FDEq]
fd_pred1 :: Pred_Loc
fd_pred2 :: Pred_Loc

pprEquation :: Equation -> SDoc

oclose :: [PredType] -> TyVarSet -> TyVarSet

improveFromInstEnv :: (InstEnv, InstEnv) -> Pred_Loc -> [Equation]

improveFromAnother :: Pred_Loc -> Pred_Loc -> [Equation]

checkInstCoverage :: Class -> [Type] -> Bool

checkFunDeps :: (InstEnv, InstEnv) -> Instance -> Maybe [Instance]

pprFundeps :: Outputable a => [FunDep a] -> SDoc